<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Category Controller
 * @author Gaurav Jain
 */
class JOOMDownloadsAdminControllerCategory extends JOOMDownloadsController
{
	/**
	 * override it due to get all uploaded files 
	 */
	public function _save(array $data, $itemId=null, $type=null)
	{
		$category  = parent::_save($data, $itemId);

		if($category){
			$categoryData 	= $category->toArray();
			$id 	 		= $categoryData['category_id'];

			//delete and save access records
			$model = $this->getModel();

			$fieldPositionsData = $model->getFieldPositionRecords($id);
			$PrevFields = array();
			foreach($fieldPositionsData as $fieldPositionData) {
				$PrevFields = $PrevFields + $fieldPositionData;
			}

			$newFields = array();
			if(isset($data['positions']) && !empty($data['positions'])){
				foreach($data['positions'] as $positonData) {
					$newFields = $newFields + $positonData;
				}
			}

			$diff = array_diff($PrevFields, $newFields);
			if(!empty($diff)) {
				$model->deleteFieldValues($id, $diff);
			}

			$model->deleteFieldPositionRecords($id);
			if(isset($data['positions']) && !empty($data['positions'])){
				$model->insertFieldPositionRecords($id, $data['positions']);
			}	
		}

		return $category;
	}
}