<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Dashboard Controller
 * @author Gaurav Jain
 */
class JOOMDownloadsAdminControllerDashboard extends JOOMDownloadsController
{
	public function getModel($name = '', $prefix = '', $config = array())
	{
		return false;
	}

	public function display($cachable = false, $urlparams = array())
	{
		return true;
	}

	public function getDownloadData() {
		$from 	= $this->input->get('from', '', 'string');
		$to 	= $this->input->get('to', '', 'string');

		$utils  = JOOMDownloadsFactory::getHelper('utils');
		$model 		= JOOMDownloadsFactory::getInstance('download', 'model');
		$filter 	= array();
		$filter['created_date'] = array(array('>=', '"'.$from.' 00:00:00"'),
										array('<=', '"'.$to.' 23:59:59"'));

		$records 	= $model->loadRecords($filter, array('limit'));

		$products = JOOMDownloadsFactory::getInstance('product', 'model')->loadRecords(array(), array('limit'));
		
		$productRecords = array();
		foreach($records as $record) {
			if(!isset($products[$record->product_id])) {die();
				continue;
			}

			if(!isset($productRecords[$record->product_id])) {
				$productRecords[$record->product_id] = array();
				$productRecords[$record->product_id]['key'] = $products[$record->product_id]->title;
				$productRecords[$record->product_id]['values'] = array();
			}

			$created_date = (string)$utils->getDayUnix($record->created_date);
			
			if(!isset($productRecords[$record->product_id]['values'][$created_date])) {
				$productRecords[$record->product_id]['values'][$created_date] = array();
				$productRecords[$record->product_id]['values'][$created_date]['x'] = $created_date;
				$productRecords[$record->product_id]['values'][$created_date]['y'] = 1;
			}
			else{
				$productRecords[$record->product_id]['values'][$created_date]['y'] += 1;
			}

			foreach ($products as $product) {
				if(!isset($productRecords[$product->product_id])) {
					$productRecords[$product->product_id] = array('key' => $product->title,
								 'values' => array());
				}

				if(!isset($productRecords[$product->product_id]['values'][$created_date])) {
					$productRecords[$product->product_id]['values'][$created_date] = array('x' => $created_date, 'y' => 0);
				}	
			}
		}

		$from = $utils->getDayUnix($from);
		$to = $utils->getDayUnix($to);
		for(; $from <= $to; $from = $from + 60 * 60 * 24) {
			foreach ($products as $product) {
				if(!isset($productRecords[$product->product_id]['values'][$from])) {
					$productRecords[$product->product_id]['values'][$from] = array();
					$productRecords[$product->product_id]['values'][$from]['x'] = $from;
					$productRecords[$product->product_id]['values'][$from]['y'] = 0;
				}
			}
		}

		$return = array();
		foreach ($products as $product) {
			if(!isset($productRecords[$product->product_id])) {
				$return[] = array('key' => $product->title, 'values' => array());
			}
			else{
				$values = array_values($productRecords[$product->product_id]['values']);
				usort($values, function($a, $b) {
				    return intval($a['x']) - intval($b['x']);
				});
				$return[] = array('key' => $product->title,
							 'values' => $values);
			}			
		}
		
		echo json_encode($return);
		exit();
	}
}