<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

class JOOMDownloadsAdminControllerField extends JOOMDownloadsController
{

	public function getControlNamePrefix()
	{
		return $this->_component->getNameSmall().'_'.$this->getName().'_form';
	}

	/**
	 * 
	 * Ajax call : Get elements of Attribute Configuration
	 */
	public function getTypeConfig()
	{
		$fieldId		=  $this->input->get('field_id',0);
		$data 			= array();
		$data['type']	=  $this->input->get('fieldType',0);
		
		$field			=  JOOMDownloadsField::getInstance($fieldId)->bind($data);

		$html 			= $field->getConfigHtml();
		$js	  			= $field->getScript(); 

		// replace specific div html and call script
		$ajaxResponse = JOOMDownloadsFactory::getAjaxResponse();
		
		$ajaxResponse->addScriptCall('joomdownloads.jQuery("#joomdownloads-field-config").html', $html);

		if(!empty($js)){		
			$ajaxResponse->addScriptCall($js);
		}
		return false;
	}

	/**
	 * Ajaxified task to add a new option to an attribute
	 */
	public function addOption()
	{
		$type      = $this->input->get('fieldType');
		$totalRows = $this->input->get('totalRows',0);
		
		$instance = JOOMDownloadsHelperField::getFieldInstance($type);
		$html = $instance->buildCounterHtml($totalRows, $type);
		$js	  = $instance->getScript(); 
		
		$ajaxResponse = JOOMDownloadsFactory::getAjaxResponse();
		$ajaxResponse->addScriptCall('joomdownloads.jQuery("#joomdownloads-field-options").append',$html);
		
		if(!empty($js)){		
			$ajaxResponse->addScriptCall($js);
		}
		return false;
	}

	/**
	 * Ajaxified task to remove any existing option
	 */
	public function removeOption()
	{
		$type      = $this->input->get('fieldType');
		$counter   = $this->input->get('counter');
		$optionId  = $this->input->get('optionId',0);
		
		if(JOOMDownloadsHelperField::getFieldInstance($type)->deleteOptions(null,$optionId)){
			$ajaxResponse = JOOMDownloadsFactory::getAjaxResponse();
			$ajaxResponse->addScriptCall('joomdownloads.jQuery("#option_row_'.$counter.'").remove');
		}	
		return false;
	}

	/**
	 * override it due to get all uploaded files 
	 */
	public function _save(array $data, $itemId=null, $type=null)
	{
		//Get All files from paycart form
		$data['_options'] = isset($data['options']) ? $data['options'] : array() ;
		return parent::_save($data, $itemId, $type);
	}

	public function save()
	{
		if($this->input->get('format', 'html') == 'json'){
			$data 	= $this->input->post->get($this->getControlNamePrefix(), array(), 'array');		

			$itemId = $data['field_id'];
			$ret 	= $this->_save($data, $itemId);
			
			$view = $this->getView();
			if($ret){
				$view->assign('success', true);
				$view->assign('field_id', $ret->getId());
			}
			else{
				$view->assign('success', false);
				$view->assign('field_id', $itemId);
			}
		
			return true;
		}
		
		return parent::save();
	}

	public function deleteField()
	{
		$field_id   = $this->input->get('field_id',0);		 
					
		$view = $this->getView();
		if(JOOMDownloadsField::getInstance($field_id)->delete()){
			$view->assign('success', true);
		}
		else{
			$view->assign('success', false);
		}
		
		return true;
	}
}