<?php
/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		JD Framework
* @subpackage	Frontend
* @contact 		contact@codextrous.com
*/
if(defined('_JEXEC')===false) die('Restricted access' );

class JDAbstractDate extends JDate
{}

//JD_TODO : Improve it for our purpose
class JDDate extends JDAbstractDate
{
	const INVOICE_FORMAT = '%A %d %b, %Y';
	const SUBSCRIPTION_PAYMENT_FORMAT = '%d %b %Y';
	const SUBSCRIPTION_PAYMENT_FORMAT_HOUR = '%d %b %Y %R%p';
	const YYYY_MM_DD_FORMAT = '%Y-%b-%d';
	const YYYY_MM_DD_FORMAT_WITHOUT_COMMA = '%Y%n%d';
	const YYYY_MM_DD_HH_MM = '%Y-%m-%d %H:%M';

	/**
	 * @param mixed $date optional the date this JDDate will represent.
	 * @param int $tzOffset optional the timezone $date is from
	 * 
	 * @return JDDate
	 */
	public static function getInstance($date = 'now', $tzOffset = null)
	{
		return new JDDate($date,$tzOffset);
	}
	
	/**
	 * @param string time 		this will be in formation of YYMMDDHHMMSS
	 * @param string function 	name of the function to execute. It could be add or sub only.
	 * 
	 * @return JDDate
	 */
	public function alter($time, $function = 'add')
	{
		JDError::assert(is_string($time), JDError::ERROR, "Time is not as string");
		
		$timeInterval = str_split($time, 2);
		$dateInterval = 'P'.$timeInterval[0].'Y'.$timeInterval[1].'M'.$timeInterval[2].'DT'.$timeInterval[3].'H'.$timeInterval[4].'M'.$timeInterval[5].'S';
		
		return $this->$function(new DateInterval($dateInterval));
	}
	
	
	public function toFormat($format=JDDate::INVOICE_FORMAT, $user=null, $config=null, $javascript=false)
	{
		return parent::format($format) ;
	}
	
	public function getClone()
	{
		return unserialize(serialize($this));
	}
	
	public function toString()
	{
		return (string)$this;
	}

	public static function timeago($time)
  	{ 
  		//JD_TODO : setting up timestamp
   	    //JD_TODO : check if user timzone was considered or not
    	$date = new JDDate($time);
    	$str  = $date->toISO8601();
        if($time=='0000-00-00 00:00:00' || !isset($time)){
     		return JText::_('PLG_SYSTEM_JD_NEVER');
   	 	}
   	 	
   	 	return "<span class='jd-timeago' title='{$str}'>$time</span>";
  	}
}
