<?php
/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		JD Framework
* @subpackage	Frontend
* @contact 		contact@codextrous.com
*/
if(defined('_JEXEC')===false) die('Restricted access' );

class JDFactory extends JFactory
{
	public static $response = null;
	
	//Returns a Model/View/Controller/Table/Lib object
    static $instance=array();
	static function getInstance($name, $type='', $prefix='JD', $refresh=false)
	{
		//generate class name
		$className	= $prefix.$type.$name;

		// Clean the name
		$className	= preg_replace( '/[^A-Z0-9_]/i', '', $className );

		//even thought class name are not case-senstivite but array index are
		//so convert the case so that if instance is available isset does not results false due to case
		$className = strtolower($className);
		//if already there is an object
		if(isset(self::$instance[$className]) && !$refresh){
			return self::$instance[$className];
		}

		//class_exists function checks if class exist,
		// and also try auto-load class if it can
		if(class_exists($className, true)===false){
			throw new RuntimeException("JD Factory::getInstance = Class $className not found");
		}

		//create new object, class must be autoloaded
		self::$instance[$className]= new $className();

		return self::$instance[$className];
	}

	/**
	 * @return JDAjaxResponse
	 */
	static public function getAjaxResponse()
  	{
 		if (self::$response === null){
 			self::$response = JDAjaxResponse::getInstance();
 		}

  		return self::$response;
  	}

  	/**
  	 * 
  	 * @Deprecated 1.1 Use Static variable
  	 * @param $set
  	 */
	static public function cleanStaticCache($set = null)
	{
		static $reset = false;

		if($set !== null)
			$reset = $set;

		return $reset;
	}
	
	public static $validator = null;
	public static function getValidator()
	{	
		if(!self::$validator){
			self::$validator = new JDValidator();
		}
		
		return self::$validator;
	}
}