<?php
/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		JD Framework
* @subpackage	Frontend
* @contact 		contact@codextrous.com
*/
if(defined('_JEXEC')===false) die('Restricted access' );

jimport('joomla.html.pagination');

class JDPagination extends JPagination
{
	function __construct(JDModel &$model)
	{
		$limit = null;
		$limitstart = null;
		$this->initDefaultStates($model, $limit,$limitstart);
        return parent::__construct($model->getTotal(), $limitstart,$limit);
	}


	public function initDefaultStates(&$model, &$limit, &$limitstart)
	{
		$statePrefix		= $model->getContext();

		$app				= JDFactory::getApplication();
		$globalListLimit	= $app->getCfg('list_limit');

		// Get pagination request variables

		//limit should be used from global space
        $limit 		= $app->getUserStateFromRequest('global.list.limit', 'limit', $globalListLimit, 'int');

        //other states should be picked from model namespace
        $context = $model->getContext();
        $limitstart = $model->getState('limitstart');

        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        //set states in model
        $model->setState('limit', $limit);
        $model->setState('limitstart', $limitstart);
	}

}
