<?php
/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		JD Framework
* @subpackage	Frontend
* @contact 		contact@codextrous.com
*/
if(defined('_JEXEC')===false) die('Restricted access' );


class JDViewAjax extends JDView
{
	public 	$_renderOptions = array('domObject'=>'jdWindowContent','domProperty'=>'innerHTML');
	public 	$headerFooters 	= true;
	
	static $actions = Array();
	
	protected function render($html, $options = array('domObject'=>'jdWindowContent','domProperty'=>'innerHTML'))
	{
		$domObject	 = $this->input->get('domObject',$options['domObject']);
		$domProperty = $this->input->get('domProperty',$options['domProperty']);

		$response	= JDFactory::getAjaxResponse();
		$response->addAssign( $domObject , $domProperty , $html );

		//JD_TODO : remove this send response, let the start file do it
		return $response->sendResponse();
	}

	//this will set popup window title
    function _setAjaxWinTitle($title)
    {
    	JDFactory::getAjaxResponse()->addScriptCall('jd.ui.dialog.title', $title);
    }

	//this will set popup window body
    function _setAjaxWinBody($body)
    {
    	JDFactory::getAjaxResponse()->addScriptCall('jd.ui.dialog.body', $body);
    }
    
    //this will set action/submit button on bottom of popup window
	function _addAjaxWinAction($text, $onButtonClick=null, $class="btn", $attr = '')
	{
		$object 		= new stdClass();
		$object->click 	= $onButtonClick;
		$object->text 	= $text;
		$object->classes= $class;
		$object->attr 	= $attr;
		
		self::$actions[]=$object;
		
    	return self::$actions;
    }

	function _setAjaxWinAction()
	{
    	if (count(self::$actions) === 0) {
    		return false;
    	}

    	JDFactory::getAjaxResponse()->addScriptCall('jd.ui.dialog.button',self::$actions);
    	return true;
    }

    function _setAjaxWinHeight($height)
    {
    	JDFactory::getAjaxResponse()->addScriptCall('jd.ui.dialog.height',$height);
    }
    
	function _setAjaxWinWidth($width)
	{
    	JDFactory::getAjaxResponse()->addScriptCall('jd.ui.dialog.width',$width);
    }
    
    function _setAjaxWinAutoclose($time)
    {
    	JDFactory::getAjaxResponse()->addScriptCall('jd.ui.dialog.autoclose',$time);
    }
}