<?php
/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		JD Framework
* @subpackage	Frontend
* @contact 		contact@codextrous.com
*/
if(defined('_JEXEC')===false) die('Restricted access' );


class JDViewHtml extends JDView
{
	/*
	| If set to false, then view should generate and set meta data
	*/
	protected $auto_generate_metadata = true;

	protected function _injectTokens($output)
	{
		// Form security via token injection
		if(JString::stristr($output, "</form>")){
			$output = preg_replace('#</form>#', JDHtml::_('form.token').'</form>', $output);
		}
		
		return $output;
	}
	
	protected function _injectScripts()
	{
		// load html assets required
		$this->loadTemplate('assets');
		
		//Get dynamic java script
		$jsScript	=	$this->getDynamicJavaScript();
		if($jsScript){
			$document	= JDFactory::getDocument();
			$document->addScriptDeclaration($jsScript);
		}
	}
	
	protected function generateMetadata()
	{	
        $app = JDFactory::getApplication();
                
		if($app->isAdmin()){
			return true;
		}
		
		$title 		= null;
		$keywords 	= null;
		$description= null; 
		$robots		= null;

		// Because the application sets a default page title,
		// we need to get it from the menu item itself
		$params		= JDFactory::getApplication()->getParams();
		$menu 	= JDFactory::getApplication()->getMenu()->getActive();
		
		$title	= $params->get('page_title', $app->getCfg('sitename'));
		if(empty($title) && $menu && $menu->title){
			$title = $menu->title ;
		}
		
		if ($params->get('menu-meta_description'))		{
			$description = $params->get('menu-meta_description');
		}

		if ($params->get('menu-meta_keywords'))		{
			$keywords= $params->get('menu-meta_keywords');
		}

		if ($params->get('robots'))		{
			$robots = $params->get('robots');
		}

		JDHelperJoomla::addDocumentMetadata($title, $keywords, $description, $robots);
	}
	
	public function render($output, $options)
	{	
		// for html pages, genertae meta data.
		if($this->auto_generate_metadata){
			$this->generateMetadata();
		}
				
		ob_start();
		echo '<div id="'.$this->_component->getNameSmall().'" class="jd-wrap '.$this->_component->getNameSmall().'-wrap">
				<div class="'.$this->_component->getNameSmall().'">
					<div class="'.$this->_component->getPrefixCss().'-component clearfix">
			 ';
		echo $this->_showHeader();
		echo $output;
		
		echo $this->_showFooter();
		echo '</div></div></div>';
		$html = ob_get_contents();
		ob_end_clean();
		
		$this->_injectScripts();
		echo $this->_injectTokens($html);
		return true;
	}
}