<?php
/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		JD Framework
* @subpackage	Frontend
* @contact 		contact@codextrous.com
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class JDHelperLoader
{
	//here we will try to register all MC and libs and helpers
	static function addAutoLoadFolder($folder, $type, $prefix='JD')
	{
		//echo "<br /> Loading folder $folder <br />";
		
		if(empty($folder))
			return;
			
		if (!is_dir($folder))
			return;
		
		$files		=	JFolder::files($folder,".php$");
		$folders	=	JFolder::folders($folder);

		
			
		if(is_array($files) && count($files)>0){
			foreach($files as $file ){
				// 	folder name starts with underscore, false means no underscore 
				if('_' == substr($file, 0, 1)){
					continue;
				}
				
				//e.g. JDController + Product
				// JDPerformance : As Class names are not case sensitive so no need to use JString::ucfirst
				$className 	= $prefix
							. $type
							. JFile::stripExt($file);
				//echo " <br /> Loading $className ".$folder.'/'.$file;
				JLoader::register($className, $folder.'/'.$file);
			}
		}
		
		if(is_array($folders) && count($folders)> 0){
			foreach($folders as $subfolder ){
				// folder name starts with underscore, false means no underscore 
				if('_' == substr($subfolder, 0, 1)){
					continue;
				}
				$subtype		= 	$type.$subfolder;
				$subfolderpath	=	$folder.'/'.$subfolder;
				self::addAutoLoadFolder($subfolderpath , $subtype , $prefix);
			}
		}
	}
	

	static function addAutoLoadFile($fileName, $className)
	{
		JLoader::register($className, $fileName);
	}

	/* View are stored very differently */
	static function addAutoLoadViews($baseFolder, $format=JD_REQUEST_DOCUMENT_FORMAT, $prefix='JD')
	{
		$folders	=	JFolder::folders($baseFolder);

		foreach($folders as $folder )
		{
			//$className 	= $prefix.'View'.$folder;
			//JLoader::register($className, $baseFolder.'/'.$folder.'/view.php');
			
			$className 	= $prefix.'View'.$folder;
			$fileName	= "view.$format.php";
			JLoader::register($className, $baseFolder.'/'.$folder.'/'.$fileName);
		}
	}

	static function includeFolder($folder, $filter=null)
	{
		foreach( JFolder::files($folder) as $file )
		{
			if($filter && in_array($file,$filter))
				continue;
			require_once  $folder.'/'.$file;
		}
	}
}