<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;
JHtml::_('jquery.ui', array('core', 'sortable'));
JDHtml::script('com_joomdownloads/jquery.ui.draggable.js');
JDHtml::script('com_joomdownloads/jquery.ui.droppable.js');
?>

<?php echo JDHtml::_('bootstrap.addTab', 'myTab', 'fields', JText::_('COM_JOOMDOWNLOADS_ADMIN_CATEGORY_FIELDS', true)); ?>
	
<script type="text/javascript">
	var jdfields = <?php echo json_encode(array_values($fields));?>;
	var jdPositionedFields = {
			productleftpanel : <?php echo isset($positionData['productleftpanel']) ? json_encode($positionData['productleftpanel']) : '[]';?>,
			productoverview : <?php echo isset($positionData['productoverview']) ? json_encode($positionData['productoverview']) : '[]';?>,
			productspecification : <?php echo isset($positionData['productspecification']) ? json_encode($positionData['productspecification']) : '[]';?>
		};
</script>

<script id="JDFieldTemplate" type="text/template"><li class="ui-state-default jd-field" data-id="">
	<div class="jd-field-list-handle"></div>
	<span class="jd-field-list-title"></span>
  	<span class="jd-field-list-buttons">
  		<span class="jd-field-list-edit"><i class="fa fa-edit"></i></span>
  		<span class="jd-field-list-delete"><i class="fa fa-trash"></i></span>
  	</span>
</li>
</script>

<script id="JDPositionFieldTemplate" type="text/template"><li class="ui-state-default jd-field" data-id="">
	<div class="jd-field-list-handle"></div>
	<span class="jd-field-list-title"></span>
  	<span class="jd-field-list-buttons">
  		<span class="jd-field-list-delete" data-position=""><i class="fa fa-trash"></i></span>
  	</span>
  	<input type="hidden" value="" name="joomdownloads_form[positions]">
</li>
</script>

<div class="row-fluid">
	<div class="span9">
		<div class="row-fluid">
			<div class="span4">
				<fieldset>
					<h3>Product Left Panel</h3>
					<hr/>
				</fieldset>
				<ul id="productleftpanel" class="jd-field-list">
				</ul>
			</div>
			<div class="span4">
				<fieldset>
					<h3>Product Overview</h3>
					<hr/>
				</fieldset>
				<ul id="productoverview" class="jd-field-list">
				</ul>
			</div>
			<div class="span4">
				<fieldset>
					<h3>Product Specification</h3>
					<hr/>
				</fieldset>
				<ul id="productspecification" class="jd-field-list">
				</ul>
			</div>
		</div>
	</div>
	<div class="span3">
		<fieldset>
			<h3>Fields</h3>
			<hr/>
		</fieldset>
		<ul id="jd-fields" class="jd-field-list">
			
		</ul>

		<div class="text-center">
			<a id="jd-create-field-modal" class="btn btn-success">
				<i class="icon-plus-sign icon-white"></i>&nbsp;<?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_CATEGORY_CREATE_FIELD');?>
			</a>
		</div>
	</div>
</div>

<script>
	(function($) {
	    $('#productleftpanel,#productoverview,#productspecification').sortable({
	    	stop: function(e, ui) {
            	jdPositionedFields[this.id] = $.map($(this).find('li'), function(el) {
                	return $(el).attr('data-id');
            	});
            }
        });
	    $('#productleftpanel,#productoverview,#productspecification').disableSelection();
	    
	    $('#productleftpanel,#productoverview,#productspecification').droppable({
				accept : function(dropElem) {
				    if(!dropElem.hasClass('jd-field')){
				    	return false;
				    }

				    var dataId = dropElem.attr('data-id');
					if($(this).find('[data-id="'+dataId+'"]').length > 0){
						return false;
					}

					return true;
				},
				hoverClass: "pc-droppable-highlight",
				drop: function(event, ui) {
					jdPositionedFields[this.id].push(ui.draggable.attr('data-id'));
		           	joomdownloads.admin.field.renderPositionFields(this.id, jdPositionedFields[this.id]);
		        }
		});

		$('#jd-create-field-modal').on('click', function () {
  			joomdownloads.admin.field.edit(0);
    		return false;
		});

		$(document).on('click', '#productleftpanel .jd-field-list-delete,#productoverview .jd-field-list-delete,#productspecification .jd-field-list-delete', function () {
			var fieldid 	= $(this).parents('.jd-field').attr('data-id');
			var position    = $(this).parents('.jd-field-list').attr('id');

			var index = jdPositionedFields[position].indexOf(fieldid);
			jdPositionedFields[position].splice(index, 1);
			joomdownloads.admin.field.renderPositionFields(position, jdPositionedFields[position]);
		});

		$(document).on('click', '#jd-fields .jd-field-list-edit', function () {
			var fieldid = $(this).parents('.jd-field').attr('data-id');
  			joomdownloads.admin.field.edit(fieldid);
    		return false;
		});

		$(document).on('click', '#jd-fields .jd-field-list-delete', function () {
			var fieldid = $(this).parents('.jd-field').attr('data-id');
  			joomdownloads.admin.field.delete(fieldid, '<?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_CATEGORY_FIELD_DELETE_CONFIRM');?>');
    		return false;
		});

		joomdownloads.admin.field.renderFields(jdfields);
		joomdownloads.admin.field.renderPositionFields('productleftpanel', jdPositionedFields['productleftpanel']);
		joomdownloads.admin.field.renderPositionFields('productoverview', jdPositionedFields['productoverview']);
		joomdownloads.admin.field.renderPositionFields('productspecification', jdPositionedFields['productspecification']);
  	})(joomdownloads.jQuery);
</script>

<style>
.jd-field-list {
    list-style: none;
    border: 1px dotted #ececec;
    padding: 0px 5px 40px 5px;
}
.jd-field-list li{
	line-height: 32px;
	margin: 5px 0px;
	padding: 2px 5px;
	background-color: #fafaf7;
    border: 1px solid #f1f1eb;
    position: relative;
    margin-bottom: 10px;
    border-radius: 4px 4px 4px 4px;
}

.jd-field-list-handle{
    position: absolute;
    top: 10px;
    left: 6px;
    width: 6px;
    height: 14px;
    background-size: 4px 4px;
    background-image: linear-gradient(0deg, #fafaf7 50%, transparent 50%, transparent), linear-gradient(90deg, transparent 50%, #fafaf7 50%, #fafaf7);
    background-color: #d4d4c9;
}

.jd-field-list-title{
	color: #8c8c85;
    font-size: 12px;
    padding: 7px 60px 8px 23px;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
}

.jd-field-list-buttons {
  position: absolute;
  right: 0;
  top: 0;
  bottom: 0;
  margin-top: -1px;
  margin-right: 10px;
  font-size: 0;
  opacity: 0;
  -webkit-transition: opacity 0.3s ease;
  transition: opacity 0.3s ease;
}
.jd-field-list-buttons > span {
  display: inline-block;
  padding: 2px 2px;
  font-size: 16px;
  color: #d4d4c9;
  cursor: pointer;
  -webkit-transition: color 0.3s ease;
  transition: color 0.3s ease;
  margin-right: 10px;
}
.jd-field-list-buttons > span:hover {
  color: #8c8c85;
}
.jd-field-list li:hover .jd-field-list-buttons {
  opacity: 1;
}

.jd-field-list li:hover{
	cursor: pointer;
}
</style>
<?php echo JDHtml::_('bootstrap.endTab');