<?php
/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/
// no direct access
defined('_JEXEC') or die;
JDHelperTemplate::loadMedia(array('nvd3', 'angular'));
?>

<script type="text/javascript">
var JDDashboardApp = angular.module('JDDashboardApp', []);
JDDashboardApp.controller('JDController', ['$scope', function($scope) {
	$scope.tab =1;
}]);
JDDashboardApp.directive('pieChart', [function() {
    	return {
      		restrict: 'E',
      		scope: {
        		// Bind the data to the directive scope.
        		data: '=',
        		// Allow the user to change the dimensions of the chart.
        		height: '@',
        		width: '@'
      		},
      		// The svg element is needed by D3.
      		template: '<svg ng-attr-height="{{ height }}" ng-attr-width="{{ width }}"></svg>',
      		link: function(scope, element) {
        		var svg = element.find('svg'),
	          		chart;

    		    // This function is called when the data is changed.
        		var update = function() {
	          		d3.select(svg[0])
            			.datum(scope.data)
            			.transition().duration(350)
		    			.call(chart);
        		};

        		// Render the chart every time the data changes.
        		// The data is serialized in order to easily check for changes.
        		scope.$watch(function() { return angular.toJson(scope.data); }, function() {
          			// The chart may not have been initialized at this point so we need
          			// to account for that.
          			if (chart) {
            			update();
          			}
        		});

        		// The chart can not be rendered at once, since the chart
        		// creation is asynchronous.
        		scope.$on('chartinit', update);

				//Donut chart example
				nv.addGraph(function() {
					chart = nv.models.pieChart()
		  						.x(function(d) { return d.label })
		  						.y(function(d) { return d.value })
		  						.showLabels(true)     //Display pie labels
		  						.labelThreshold(.05)  //Configure the minimum slice size for labels to show up
		  						.labelType("percent") //Configure what type of data to show in the label. Can be "key", "value" or "percent"
		  						.donut(true)          //Turn on Donut mode. Makes pie chart look tasty!
		  						.donutRatio(0.35)     //Configure how big you want the donut hole size to be.
		  						;
					chart.valueFormat(d3.format('d'));
 					nv.utils.windowResize(function() {
            		chart.update()
          		});

				// Emit an event so we can know that the
          		// chart has been initialized.
          		scope.$emit('chartinit');

				return chart;
			});
		}
    }
}]);

JDDashboardApp.directive('multiBarChart', [function() {
        return {
            restrict: 'E',
            scope: {
                // Bind the data to the directive scope.
                data: '=',
                // Allow the user to change the dimensions of the chart.
                height: '@',
                width: '@'
            },
            // The svg element is needed by D3.
            template: '<svg ng-attr-height="{{ height }}" ng-attr-width="{{ width }}"></svg>',
            link: function(scope, element) {
                var svg = element.find('svg'),
                    chart;

                // This function is called when the data is changed.
                var update = function() {
                    d3.select(svg[0])
                        .datum(scope.data)
                        // .transition().duration(350)
                        .call(chart);
                };

                // Render the chart every time the data changes.
                // The data is serialized in order to easily check for changes.
                scope.$watch(function() { return angular.toJson(scope.data); }, function() {
                    // The chart may not have been initialized at this point so we need
                    // to account for that.
                    if (chart) {
                        update();
                    }
                });

                // The chart can not be rendered at once, since the chart
                // creation is asynchronous.
                scope.$on('chartinit', update);

                //Donut chart example
                nv.addGraph(function() {
                    chart = nv.models.multiBarChart()
                            .reduceXTicks(true)
                            .showControls(true)
                            .groupSpacing(0.5) ;

                    chart.xAxis
                        .tickFormat(function(d) {
                            return d3.time.format('%d-%b-%Y')(new Date(parseInt(d*1000)))
                        });
                    chart.yAxis.axisLabel("<?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_DASHBOARD_CHART_DOWNLOADS');?>")
                    chart.yAxis.tickFormat(d3.format('d'));
        
                    nv.utils.windowResize(function() {
                    chart.update()
                });

                // Emit an event so we can know that the
                // chart has been initialized.
                scope.$emit('chartinit');

                return chart;
            });
        }
    }
}]);

joomdownloads.jQuery(document).ready(function(){
joomdownloads.jQuery('#myTab a').click(function (e) {
    // e.preventDefault()
    // joomdownloads.jQuery(this).tab('show')
   window.dispatchEvent(new Event('resize'));
});
});
</script>

<div class="row-fluid" ng-app="JDDashboardApp">
	<div class="span3">
		<?php echo JLayoutHelper::render('adminmenu', 'dashboard');?>
	</div>
	<div class="span9" ng-controller="JDController">
		<div>
        	<ul id="myTab" class="nav nav-tabs">
                <li class="active">
                    <a  ng-click="tab = 1" href data-toggle="tab">
                        <?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_DASHBOARD_OVERVIEW');?>
                    </a>
                </li>
                <li class="">
                    <a href ng-click="tab = 2" data-toggle="tab">
                        <?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_DASHBOARD_DETAILED');?>
                    </a>
                </li>
            </ul>
        </div>

		<div class="tab-content">
            <div ng-show="tab === 1">
        		<div class="row-fluid">			
        			<?php echo $this->loadTemplate('chart_overview');?>
        		</div>
    		</div>

    		<div ng-show="tab === 2">
        		<div class="row-fluid">			
        			<?php echo $this->loadTemplate('chart_detailed');?>
        		</div>
    		</div>
		</div>
	</div>
</div>

<?php 
