<?php
/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/
// no direct access
defined('_JEXEC') or die;
$db = JFactory::getDbo();
$query = $db->getQuery(true);
$query->select(array('IF(hits, title, CONCAT(title, " (", hits, ")")) as label', 'hits as value'))
		->from('#__joomdownloads_product')
		->order('value DESC');
$db->setQuery($query);
$records = $db->loadObjectList();

?>
<div ng-controller="MostPopularController as MPC">
	<div class="span6">
		<h3 class="pull-left"><?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_DASHBOARD_MOST_VIEWED_PRODUCTS');?></h3>
		<span class="pull-right">Top
			<select class="input-mini" data-ng-model="numberOfProducts">
				<option value="5">5</option>
				<option value="10">10</option>
				<option value="20">20</option>
				<option value="20">50</option>
				<option value="all">All</option>
			</select>
		</span>
	  	<pie-chart height="400px" data="data"></pie-chart>
	</div>

	<div class="span6">
		<h3 class="pull-left"><?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_DASHBOARD_LEAST_VIEWED_PRODUCTS');?></h3>
		<span class="pull-right">Bottom
			<select class="input-mini" data-ng-model="numberOfProductsReverse">
				<option value="5">5</option>
				<option value="10">10</option>
				<option value="20">20</option>
				<option value="20">50</option>
				<option value="all">All</option>
			</select>
		</span>
	  	<pie-chart height="400px" data="dataReverse"></pie-chart>
	</div>
</div>

<script>
    JDDashboardApp.controller('MostPopularController', ['$scope', function($scope) {
	$scope.numberOfProducts = 5;
	$scope.numberOfProductsReverse = 5;
	$scope.allData = <?php echo json_encode($records);?>;
	$scope.allDataReverse = <?php echo json_encode(array_reverse($records));?>;

	$scope.$watch("numberOfProducts", function() {
		if ($scope.numberOfProducts === 'all') {
			$scope.data = $scope.allData;
		}
		else{
			$scope.data = $scope.allData.slice(0, $scope.numberOfProducts);
		}
	});

	$scope.$watch("numberOfProductsReverse", function() {
		if ($scope.numberOfProductsReverse === 'all') {
			$scope.dataReverse = $scope.allDataReverse;
		}
		else{
			$scope.dataReverse = $scope.allDataReverse.slice(0, $scope.numberOfProductsReverse);
		}
	});
}]);
</script>
<?php

$db = JFactory::getDbo();
$sql = 'SELECT IF(d.downloads, p.title, CONCAT(p.title, " (0)")) as `label`, d.downloads as `value` '
		.'FROM `#__joomdownloads_product` as p '
		.'LEFT JOIN ( '
		.'SELECT product_id, count(product_id) as downloads '
		.'FROM `#__joomdownloads_download` '
		.'GROUP BY `product_id`) as d '
		.'ON (p.product_id = d.product_id) '
		.'ORDER BY d.downloads DESC';
$db->setQuery($sql);
$records = $db->loadObjectList();

?>
<div ng-controller="MostDownloadController as MDC">
	<div class="span6">
		<h3 class="pull-left"><?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_DASHBOARD_MOST_DOWNLOADED_PRODUCTS');?></h3>
		<span class="pull-right">Top
			<select class="input-mini" data-ng-model="numberOfProducts">
				<option value="5">5</option>
				<option value="10">10</option>
				<option value="20">20</option>
				<option value="20">50</option>
				<option value="all">All</option>
			</select>
		</span>
	  	<pie-chart height="400px" data="data"></pie-chart>
	</div>

	<div class="span6">
		<h3 class="pull-left"><?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_DASHBOARD_LEAST_DOWNLOADED_PRODUCTS');?></h3>
		<span class="pull-right">Bottom
			<select class="input-mini" data-ng-model="numberOfProductsReverse">
				<option value="5">5</option>
				<option value="10">10</option>
				<option value="20">20</option>
				<option value="20">50</option>
				<option value="all">All</option>
			</select>
		</span>
	  	<pie-chart height="400px" data="dataReverse"></pie-chart>
	</div>
</div>

<script>
JDDashboardApp.controller('MostDownloadController', ['$scope', function($scope) {
	$scope.numberOfProducts = 5;
	$scope.numberOfProductsReverse = 5;
	$scope.allData = <?php echo json_encode($records);?>;
	$scope.allDataReverse = <?php echo json_encode(array_reverse($records));?>;

	$scope.$watch("numberOfProducts", function() {
		if ($scope.numberOfProducts === 'all') {
			$scope.data = $scope.allData;
		}
		else{
			$scope.data = $scope.allData.slice(0, $scope.numberOfProducts);
		}
	});

	$scope.$watch("numberOfProductsReverse", function() {
		if ($scope.numberOfProductsReverse === 'all') {
			$scope.dataReverse = $scope.allDataReverse;
		}
		else{
			$scope.dataReverse = $scope.allDataReverse.slice(0, $scope.numberOfProductsReverse);
		}
	});
}]);
</script>