<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;
JHtml::_('behavior.tooltip');
JHtml::_('behavior.keepalive');
JHtml::_('behavior.formvalidation');
?>
<form action="<?php echo $uri; ?>" method="post" name="adminForm" id="adminForm" class="form-validate" enctype="multipart/form-data">
	<?php echo JDHtml::_('bootstrap.startTabSet', 'myTab', array('active' => 'basic')); ?>
	<?php echo JDHtml::_('bootstrap.addTab', 'myTab', 'basic', JText::_('COM_JOOMDOWNLOADS_ADMIN_PRODUCT_DETAILS', true)); ?>
	<div class="row-fluid">
		<div class="span6">
			<h1><?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_PRODUCT_DETAILS');?></h1>
			<hr/>
			<fieldset class="form-horizontal">
				<?php foreach(array('title', 'alias', 'category_id', 'published') as $fieldname):?>
					<?php $field = $form->getField($fieldname); ?>		
					<div class="control-group">
						<div class="control-label"><?php echo $field->label; ?></div>
						<div class="controls"><?php echo $field->input;?></div>
					</div>
				<?php endforeach;?>

				<?php $field = $form->getField('image'); ?>		
				<div class="control-group">
					<div class="control-label"><?php echo $field->label; ?></div>
					<div class="controls">
						<?php $value = $field->value;?>
						<?php if(!empty($value)) : ?>
							<div class="row-fluid">							
								<img src="<?php echo JURI::root().$value;?>" class="thumbnail span6">
							</div>
						<?php endif;?>
						<?php echo $field->input;?>
					</div>
				</div>

				<?php foreach(array('created_date', 'modified_date') as $fieldname):?>
					<?php $field = $form->getField($fieldname); ?>		
					<div class="control-group">
						<div class="control-label"><?php echo $field->label; ?></div>
						<div class="controls"><?php echo $field->input;?></div>
					</div>
				<?php endforeach;?>
			</fieldset>
		</div>
	</div>
	<br/>
	<div class="row-fluid">
		<?php $field = $form->getField('description'); ?>		
		<div class="control-group">
			<div class="control-label"><?php echo $field->label; ?></div>
			<div class="controls"><?php echo $field->input;?></div>
		</div>
	</div>
	<br/>
	<h1><?php echo JText::_('COM_JOOMDOWNLOADS_ADMIN_PRODUCT_OTHER_PARAMS');?></h1>
	<hr/>
	<div class="row-fluid">
		<div class="span6">
			<fieldset class="form-horizontal">	
				<?php $fields = $form->getFieldset('metadata');?>			
				<?php foreach ($fields as $field) :// Iterate through the fields in the set and display them.?>
					<?php if ($field->hidden):// If the field is hidden, just display the input.?>
						<?php echo $field->input;?>
					<?php else:?>
						<div class="control-group">
							<div class="control-label">
							<?php echo $field->label; ?>							
							</div>
							<div class="controls">
								<?php echo $field->input;?>
							</div>
						</div>
					<?php endif;?>
				<?php endforeach;?>
			</fieldset>
		</div>
	</div>

	
	<!--  HIDDEN -->
	<?php echo $form->getField('product_id')->input;?>
	<input type="hidden" name="task" value="save" />	
	<?php echo JDHtml::_('bootstrap.endTab'); ?>

	<?php if ($enableFields) : ?>
		<?php echo $this->loadTemplate('edit_fields');?>
	<?php endif; ?>

	<?php echo JDHtml::_('bootstrap.endTabSet'); ?>
</form>
