<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Product Html View
* @author Gaurav Jain
 */
require_once dirname(__FILE__).'/view.php';
class JOOMDownloadsAdminViewProduct extends JOOMDownloadsAdminBaseViewProduct
{	
	public function edit($tpl=null) 
	{	
		JDHelperJoomla::loadPlugins('joomdownloads');
		
		$itemId	=  $this->getModel()->getId();
		$item	=  JOOMDownloadsProduct::getInstance($itemId);
		$form 	= $item->getModelform()->getForm($item);
		$productData = $item->toArray();

		$fieldValues 	= array();
		$positionData 	= array('productleftpanel' => array(),
								'productoverview' => array(),
								'productspecification' => array());

		$enableFields = JDHelperJoomla::getPluginStatus('fields', 'joomdownloads');

		if($itemId){
			if($enableFields) {
				$fieldValues  = $this->getModel()->getFieldValues($itemId);			
				$positionData = JOOMDownloadsFactory::getInstance('category', 'model')
								->getFieldPositionRecords($productData['category_id']);
			}
		}
		
		$this->assign('positions' , array('productleftpanel', 'productoverview', 'productspecification'));
		$this->assign('form', $form);
		$this->assign('fieldValues', $fieldValues);
		$this->assign('positionData', $positionData);

		$this->assign('enableFields', $enableFields);
		$this->assign('itemId', $itemId);

		return parent::edit($tpl);
	}
	
	public function _displayGrid($records)
	{
		parent::_displayGrid($records);
		$cat_helper = JOOMDownloadsFactory::getHelper('category');
		$category = $cat_helper->getCategory();
		$this->assign('category', $category);
		return true;
	}
}
