/**
* @copyright	Copyright (C) 2009-2012 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		JOOMDOWNLOADS
* @contact 		dev@codextrous.com
*/

//define joomdownloads, if not defined.
if (typeof(joomdownloads)=='undefined'){
	var joomdownloads = {}
}

// all admin function should be in admin scope 
if(typeof(joomdownloads.admin)=='undefined'){
	joomdownloads.admin = {};
}

//all admin function should be in admin scope 
if(typeof(Joomla)=='undefined'){
	Joomla = {};
}


(function($){
// START : 	
// Scoping code for easy and non-conflicting access to $.
// Should be first line, write code below this line.	
	
	
/*--------------------------------------------------------------
joomdownloads.admin.grid
	submit
	filters
--------------------------------------------------------------*/
joomdownloads.admin.grid = {
		
		//default submit function
		submit : function( view, action, validActions){
			
			// try views function if exist
			var funcName = view+'_'+ action ; 
			if(this[funcName] instanceof Function) {
				if(this[funcName].apply(this) == false)
					return false;
			}
			
			// then lastly submit form
			//submitform( action );
			if (action) {
		        document.adminForm.task.value=action;
		    }
			
			// validate actions
			//XITODO : send values as key of array , saving a loop
			validActions = eval(validActions);
			var isValidAction = false;
			for(var i=0; i < validActions.length ; i++){
				if(validActions[i] == action){
					isValidAction = true;
					break;
				}
			}
			
			if(isValidAction){
				if (document.formvalidator.isValid(document.getElementById("adminForm"))) {
					Joomla.submitform(action, document.getElementById('adminForm'));
				}				
			}else{
				Joomla.submitform(action, document.getElementById('adminForm'));
			}
		},
		
		filters : {
			reset : function(form){
				 // loop through form elements
			    var str = new Array();
                            var i=0;
			    for(i=0; i<form.elements.length; i++)
			    {
			        var string = form.elements[i].name;
			        if (string && string.substring(0,6) == 'filter' && (string!='filter_reset' && string!='filter_submit'))
			        {
			            form.elements[i].value = '';
			        }
			    }
				joomdownloads.admin.grid.submit(view,null,validActions);
			}
		}
};

/*--------------------------------------------------------------
  on Document ready 
--------------------------------------------------------------*/
$(document).ready(function(){
	
});

joomdownloads.radio = {
		init : function(){
			 //needed some fix to show radio button properly in front-end
		    // Turn radios into btn-group
			$('.radio.btn-group label').addClass('btn');
			
			$(".btn-group input[checked=checked]").each(function()
			{
				if ($(this).val() == '') {
					$("label[for=" + $(this).attr('id') + "]").addClass('active btn-primary');
				} else if ($(this).val() == 0) {
					$("label[for=" + $(this).attr('id') + "]").addClass('active btn-danger');
				} else {
					$("label[for=" + $(this).attr('id') + "]").addClass('active btn-success');
				}
			});
		},
		
		applyBtnClass : function(btn){
			  var label = $(btn);
			  var input = $('#' + label.attr('for'));

			  if (!input.prop('checked')) {
				  label.closest('.btn-group').find("label").removeClass('active btn-success btn-danger btn-primary');
				  if (input.val() == '') {
					  label.addClass('active btn-primary');
				  } else if (input.val() == 0) {
					  label.addClass('active btn-danger');
				  } else {
					  label.addClass('active btn-success');
				  }
				  input.prop('checked', true);
			  }
		}
};

joomdownloads.admin.field = {
	edit:function(id) {
		var link  = 'index.php?option=com_joomdownloads&view=field&task=edit&field_id='+id;
		joomdownloads.url.modal(link, {width:'800px', height: 'auto'});
	},

	removeOption : function(type,counter){	
        var optionId = $('#joomdownloads_field_form_fieldoption_id_'+counter).val();
		var url = 'index.php?option=com_joomdownloads&view=productattribute&task=removeOption&attributeType='+type+'&counter='+counter+'&optionId='+optionId;
		joomdownloads.ajax.go(url);
	},
		
	addOption : function(type){
		var url = 'index.php?option=com_joomdownloads&view=field&task=addOption&fieldType='+type+'&totalRows='+fieldCounter;
		fieldCounter++;
		joomdownloads.ajax.go(url);
	},
	
	getTypeConfig : function(type, id){
		var url  = 'index.php?option=com_joomdownloads&task=getTypeConfig&view=field&fieldType='+type+'&field_id='+id;
		joomdownloads.ajax.go(url);
	},

	save : function(){
		$('#jd-field-error').addClass('hide');
		if(!joomdownloads.formvalidator.isValid(document.getElementById('jd-field-form'))){
			return false;
		}

		var data = $('#jd-field-form').serializeArray();
		$.ajax({
			url		: jd.url.route('index.php?option=com_joomdownloads&task=save&view=field&format=json'),
		    cache	: false,
			data	: $.param(data),						
			type 	: 'POST',						
		    success : function( response ) {
				//clear data (remove warnings and error)
				response = joomdownloads.ajax.junkFilter(response);
		    	if(response.success){
					joomdownloads.ui.dialog.close();
					var found = false;
					jdfields.forEach(function(field, index){
						if(parseInt(field.field_id) == parseInt(response.field.field_id)){
							found = index;
						}
					});

					if(found === false){
						jdfields.push(response.field);
					}
					else{
						jdfields[found] = response.field;
					}

					joomdownloads.admin.field.renderFields(jdfields);
					joomdownloads.admin.field.renderPositionFields('productleftpanel', jdPositionedFields.productleftpanel);
					joomdownloads.admin.field.renderPositionFields('productoverview', jdPositionedFields.productoverview);
					joomdownloads.admin.field.renderPositionFields('productspecification', jdPositionedFields.productspecification);
		    	}
		    	else{
					$('#jd-field-error').removeClass('hide');
					$('#jd-field-error').html(response.message);
		    	}
				return true;
		    },

			error : function( response ) {
		    	console.log ({"Error on fetching JSON data :  " :response} );
				return response;
		    }
		});
	},

	delete : function(id, confirmMsg){
		if(!confirm(confirmMsg)) {
			return true;
		}

		$.ajax({
			url		: jd.url.route('index.php?option=com_joomdownloads&task=deleteField&view=field&format=json&field_id='+id),
		    cache	: false,
			type 	: 'GET',						
		    success : function( response ) {
				//clear data (remove warnings and error)
				response = joomdownloads.ajax.junkFilter(response);
		    	if(response.success){					
					var found = false;
					jdfields.forEach(function(field, index){
						if(parseInt(field.field_id) == parseInt(id)){
							found = index;
						}
					});

					if(found !== false) {
						delete jdfields[found];
					}

					joomdownloads.admin.field.renderFields(jdfields);
					joomdownloads.admin.field.renderPositionFields('productleftpanel', jdPositionedFields.productleftpanel);
					joomdownloads.admin.field.renderPositionFields('productoverview', jdPositionedFields.productoverview);
					joomdownloads.admin.field.renderPositionFields('productspecification', jdPositionedFields.productspecification);
		    	}
		    	else{
					alert(response.message);
		    	}
				return true;
		    },

			error : function( response ) {
		    	console.log ({"Error on fetching JSON data :  " :response} );
				return response;
		    }
		});
	},

	renderField : function(field) {
		var JDFieldTemplate = $('#JDFieldTemplate').html();
		var $JDFieldTemplate = $(JDFieldTemplate);
		$JDFieldTemplate.attr('data-id', field.field_id);
		$JDFieldTemplate.find('.jd-field-list-title').html(field.title);

		return $JDFieldTemplate;
	},

	renderFields : function(fields) {
		var $fieldListContainer = $('#jd-fields');
		$fieldListContainer.empty();
		var $fields = fields.map(function (field, index) {
			return joomdownloads.admin.field.renderField(field);
		});
		$fieldListContainer.append($fields);

		setTimeout(function () {
			$('#jd-fields .jd-field').draggable({helper: "clone", revert: 'invalid'});
		}, 0);		
	},

	renderPositionField : function(position, field) {
		var JDFieldTemplate = $('#JDPositionFieldTemplate').html();
		var $JDFieldTemplate = $(JDFieldTemplate);
		$JDFieldTemplate.attr('data-id', field.field_id);
		$JDFieldTemplate.find('.jd-field-list-title').html(field.title);
		var $hidden = $JDFieldTemplate.find('input[type="hidden"]');
		$hidden.val(field.field_id);
		$hidden.attr('name', $hidden.attr('name') + '['+position+'][]');

		return $JDFieldTemplate;
	},

	renderPositionFields : function(position, fields) {
		var $fieldListContainer = $('#'+position);
		$fieldListContainer.empty();
		var $positionsfields = [];
		fields.map(function (fieldid, index) {
			jdfields.map(function(field, index){
				if(parseInt(field.field_id) == parseInt(fieldid)){
					$positionsfields.push(joomdownloads.admin.field.renderPositionField(position, field));
				}
			});
		});
		$fieldListContainer.append($positionsfields);
		
		setTimeout(function () {
			// $('#jd-fields .jd-field').draggable({helper: "clone", revert: 'invalid'});
		}, 0);		
	}
};
//ENDING :
//Scoping code for easy and non-conflicting access to $.
//Should be last line, write code above this line.
})(joomdownloads.jQuery);
