<?php
/**
* @copyright		coDExtrous.com
* @license			GNU GPL 3
* @package			joomdownloads
* @subpackage		Backend
*/
if(defined('_JEXEC')===false) die();

class Com_joomdownloadsInstallerScript
{
	function uninstall($parent)
	{
		return true;
	}

	/**
	 * Runs on installation
	 * 
	 * @param JInstaller $parent 
	 */
	public function install($parent)
	{
		$this->installExtensions();

		$extensions 	= array();
		$extensions[] 	= array('type'=>'system', 'name'=>'jd');
        $extensions[] 	= array('type'=>'system', 'name'=>'joomdownloadsupdate');
		$extensions[] 	= array('type'=>'joomdownloads', 'name'=>'fields');
		$extensions[] 	= array('type'=>'joomdownloads', 'name'=>'jusergroup');
		//$extensions[] 	= array('type'=>'joomdownloads', 'name'=>'payplans');

		$this->changeExtensionState($extensions);
		return true;
	}

	
	function update($parent)
	{
		self::install($parent);
	}

	function installExtensions($path=null,$delFolder=true)
	{
		//if no path defined, use default path
		if($path==null)
			$path = dirname(__FILE__).'/admin/install/extensions';

		//get instance of installer
		$installer =  new JInstaller();

		$extensions	= JFolder::folders($path);

		//no extension to install
		if(empty($extensions))
			return true;

		//install all extensions
		foreach ($extensions as $extension)
		{
			$msg = " ". $extension . ' : Installed Successfully ';

			// Install the packages
			if($installer->install("{$path}/{$extension}")==false){
				$msg = " ". $extension . ' : Installation Failed. Please try to reinstall. [Supportive plugin/module for CD Downloads]';
			}

			//enque the message
			JFactory::getApplication()->enqueueMessage($msg);
		}

		if($delFolder){
			$delPath = JPATH_ADMINISTRATOR.'/components/com_joomdownloads/install/extensions';
			JFolder::delete($delPath);
		}

		return true;
	}

	function changeExtensionState($extensions = array(), $state = 1)
	{
		if(empty($extensions)){
			return true;
		}

		$db		= JFactory::getDBO();
		$query		= 'UPDATE '. $db->quoteName( '#__extensions' )
				. ' SET   '. $db->quoteName('enabled').'='.$db->Quote($state);

		$subQuery = array();
		foreach($extensions as $extension => $value){
			$subQuery[] = '('.$db->quoteName('element').'='.$db->Quote($value['name'])
				    . ' AND ' . $db->quoteName('folder').'='.$db->Quote($value['type'])
			            .'  AND `type`="plugin"  )   ';
		}

		$query .= 'WHERE '.implode(' OR ', $subQuery);

		$db->setQuery($query);
		return $db->query();
	}
}
