<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Front-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Factory
 * @author Gaurav Jain
 */
class JOOMDownloadsFactory extends JDFactory
{
	static function getInstance($name, $type='', $prefix='JOOMDownloads', $refresh=false)
	{
		return parent::getInstance($name, $type, $prefix, $refresh);
	}

	static function getHelper($name = null, $type = 'Helper', $prefix = 'JOOMDownloads')
	{
		static $helper = null;
		
		if($helper === null){						
			$path 	= JOOMDOWNLOADS_PATH_CORE.'/helpers';
			$files 	= JFolder::files($path, '.php');
			$helper = new stdClass();
			
			foreach($files as $file){
				$file = preg_replace('#.php#', '', $file);
				$class_name 	= $prefix.$type.$file;
				$helper->$file 	= new $class_name();
			}
		}
		
		if($name != null){
			if(isset($helper->$name)){
				return $helper->$name;
			}
			
			//XITODO : raise error
		}
		
		return $helper;	
	}
}
