<?php

/**
 * @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * @package 	JOOMDOWNLOADS
 * @subpackage	Front-end
 * @contact		contact@codextrous.com
 */

// no direct access
defined('_JEXEC') or die;

if(JD_REQUEST_DOCUMENT_FORMAT === 'ajax'){
	class JOOMDownloadsViewbase extends JDViewAjax{}
}elseif(JD_REQUEST_DOCUMENT_FORMAT === 'json'){
	class JOOMDownloadsViewbase extends JDViewJson{}
}else{
	class JOOMDownloadsViewbase extends JDViewHtml{}
}


/** 
 * Base View
* @author Gaurav Jain
 */
class JOOMDownloadsView extends JOOMDownloadsViewbase 
{
	public $_component = JOOMDOWNLOADS_COMPONENT_NAME;
	
	public function __construct($config = array())
	{
		parent::__construct($config);
		
		// intialize input
		$this->input = JOOMDownloadsFactory::getApplication()->input;
		return $this;
	}

	protected function _adminGridToolbar()
	{
		// Sample Toolbar icons
		JDHelperToolbar::addNew('new');
		JDHelperToolbar::editList();
		JDHelperToolbar::divider();
		JDHelperToolbar::publish();
		JDHelperToolbar::unpublish();
		JDHelperToolbar::divider();
		JDHelperToolbar::deleteList('COM_JOOMDOWNLOADS_ADMIN_CONFIRM_DELETE_'.strtoupper($this->getName()));
        JToolbarHelper::preferences('com_joomdownloads');
	}

	protected function _adminEditToolbar()
	{   
	    $model = $this->getModel();
		JDHelperToolbar::apply();
		JDHelperToolbar::save();
		JDHelperToolbar::cancel();
		JDHelperToolbar::divider();
	    
	}

	protected function _showAdminFooter()
	{
		ob_start();
		?>
       
         	 <div class="powered-by">
				<div class="pull-right muted">
				   Powered by <a href="http://www.codextrous.com/joomla-components/joomla-download-manager.html" target="_blank" >Joom Downloads</a>
				    | Version <strong><?php echo JOOMDOWNLOAD_VERSION; ?></strong> 	  	
		    	</div>
			</div>
		<?php 
		$content = ob_get_contents();
		ob_end_clean();
		return $content;
	}
	
	protected function _showFooter()
	{
		// Do no apply on ajax request
		if(JD_REQUEST_DOCUMENT_FORMAT != 'html'){
			return '';
		}
		
		if(JDFactory::getApplication()->input->get('tmpl')=='component'){
			return '';
		}
		
		//always shown in admin
		if(JDFactory::getApplication()->isAdmin()==true){
			return $this->_showAdminFooter();
		}
		
		if (JOOMDOWNLOADS_PAID === false){
			ob_start();
			?>
	       
	         	 <div class="powered-by">
					<div class="pull-center">
					   Powered by <a href="http://www.codextrous.com" target="_blank" >Codextrous</a>
			    	</div>
				</div>
			<?php 
			$content = ob_get_contents();
			ob_end_clean();
			return $content;
		}
		
		return '';
	}
}
