<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Front-end
* @contact		contact@codextrous.com
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class JOOMDownloadsField extends JOOMDownloadsLib
{
	// Table field
	protected $field_id		 =	0; 
	protected $type 		 =	'';
	protected $css_class	 =	'';
	protected $filterable	 = 	1;
	protected $searchable	 =	1;
	protected $published	 =	1;
	protected $config		 =  null;
	protected $ordering		 =	0;
	protected $title 		 = '';
	
	//attribute specific data
	protected $_options = array();
	
	public function reset() 
	{	
		$this->field_id	 	 =	0; 
		$this->type 		 =	'';
		$this->css_class	 =	'';
		$this->filterable	 = 	1;
		$this->searchable	 =	1;
		$this->published 	 =	1;
		$this->ordering		 =	0;
		$this->config		 =  new JDRegistry();
		$this->title 		 = '';
		
		//attribute specific options
		$this->_options = array();
		
		return $this;
	}
	
	public static function getInstance($id = 0, $data = null, $dummy1 = null, $dummy2 = null)
	{
		return parent::getInstance('field', $id, $data);
	}	
	
	/**
	 * bind XML field on lib object
	 * 
	 * @see plugins/system/jd/jd/jd/JDLib::bind()
	 */
	public function bind($data, $ignore=array()) 
	{
		if(is_object($data)){
			$data = (array) ($data);
		}

		// Parent bind	
		parent::bind($data, $ignore);
		
		//set options
		if( isset($data['_options'])) {
			$this->_options = $data['_options'];
		}

		//set attribute options
		$this->setOptions(JOOMDownloadsHelperField::getFieldInstance($this->type)->buildOptions($this, $data));		
		
		return $this;
	}

	public function getType(){
		return $this->type;
	}

	public function getTitle(){
		return $this->title;
	}

	public function getConfig(){
		return $this->config;
	}
	
	protected function _save($previousObject)
	{
		$id = parent::_save($previousObject);
		
		// if save fail
		if (!$id) { 
			return false;
		}
		
		// Correct the id, for new records required
		$this->setId($id);
		
		//save attribute config
		JOOMDownloadsHelperField::getFieldInstance($this->type)->saveOptions($this);
		
		return $id;
	}
	
	public function getOptions()
	{
		return $this->_options;
	}
	
	public function setOptions($options)
	{
		if(!empty($options)){
			$this->_options = $options;
		}
		
		return $this;
	}

	function getConfigHtml($selectedValue = '', Array $options = array())
	{
		if(empty($this->type)){
			return '';
		}
		
		return JOOMDownloadsHelperField::getFieldInstance($this->type)->getConfigHtml($this,$selectedValue,$options);
	}
	
	function getScript()
	{
		return JOOMDownloadsHelperField::getFieldInstance($this->type)->getScript();
	}

	function getEditHtml($productId, $selectedValue = '', Array $options = array())
	{
		$product = JOOMDownloadsProduct::getInstance($productId);
		return JOOMDownloadsHelperField::getFieldInstance($this->type)->getEditHtml($product, $this,$selectedValue,$options);
	}	

	function getDisplayHtml($productId, $selectedValue = '', Array $options = array())
	{
		$product = JOOMDownloadsProduct::getInstance($productId);
		return JOOMDownloadsHelperField::getFieldInstance($this->type)
				->getDisplayHtml($product, $this,$selectedValue,$options);
	}	
}