<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Front-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Release Lib
 * @author Gaurav Jain
 */
class JOOMDownloadsRelease extends JOOMDownloadsLib
{
	protected $release_id	= 0;
	protected $version		= '';
	protected $product_id	= '';
	protected $ordering		= 0;
	protected $published	= 1;
	protected $modified_date = null;
	protected $released_date = null;
	protected $filename 	= '';
	protected $created_date	= null;
	protected $params       = null;

	public function reset()
	{
		$this->release_id	= 0;
		$this->version		= '';
		$this->product_id	= '';
		$this->ordering		= 0;
		$this->published	= 1;	
		$this->modified_date= JDdate::getInstance('now');
		$this->created_date = JDDate::getInstance('now');
		$this->released_date= JDDate::getInstance('now');
		$this->filename 	= '';
		$this->params       = new JDRegistry();
		return $this;
	}
	
	public static function getInstance($id = 0, $data = null, $dummy1 = null, $dummy2 = null)
	{
		return parent::getInstance('Release', $id, $data);
	}

	public function getDownloadFile()
	{
		$file = JOOMDOWNLOADS_PATH_RELEASE.'/'.$this->filename;
		if(JFile::exists($file)){
			return $file;
		}

		return '';
	}

	public function getDownloadFileUrl()
	{
		$file = JOOMDOWNLOADS_PATH_RELEASE.'/'.$this->filename;
		if(JFile::exists($file)){
			return JURI::root().'media/com_joomdownloads/releases/'.$this->filename;
		}

		return '';
	}

	public function addDownload()
	{
		$download = JOOMDownloadsDownload::getInstance();
		$download->bind(array('product_id' => $this->product_id, 'release_id' => $this->release_id));
		return $download->save();
	}
}
