<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Category Model
 * @author Gaurav Jain
 */
class JOOMDownloadsModelCategory extends JOOMDownloadsModel
{
	public $filterMatchOpeartor = array(
		'title' => array('LIKE'),
		'published' => array('='));

	public function deleteFieldPositionRecords($categoryId)
	{
		$db = $this->_db;
		$query = $db->getQuery(true);
		$query->delete()
				->from('`#__joomdownloads_fieldposition`')
				->where('`category_id` = '.$db->quote($categoryId));

		$db->setQuery($query);
		return $db->query();
	}

	public function insertFieldPositionRecords($categoryId, $positionData)
	{
		$db = $this->_db;
		$insert = array();
		foreach($positionData as $position => $fieldIds){
			if(empty($fieldIds)){
				continue;
			}

			if(!is_array($fieldIds)){
				$insert[] = '('.$db->quote($categoryId).', '.$db->quote($fieldIds).', '.$db->quote($position).', 1)';
				continue;
			}
			$counter = 1;
			foreach($fieldIds as $fieldId){
				$insert[] = '('.$db->quote($categoryId).', '.$db->quote($fieldId).', '.$db->quote($position).', '.$counter++.')';
			}
		}

		if(empty($insert)){
			return true;
		}
		
		$db = $this->_db;
		$query = 'INSERT INTO `#__joomdownloads_fieldposition` (`category_id`, `field_id`, `position`, `field_ordering`) VALUES '.
				 implode(',', $insert);
				 
		$db->setQuery($query);
		return $db->query();
	}

	public function getFieldPositionRecords($categoryId)
	{
		$db = $this->_db;
		$query = $db->getQuery(true);
		$query->select('*')
				->from('`#__joomdownloads_fieldposition`')
				->where('`category_id` = '.$db->quote($categoryId))
				->order('field_ordering', 'asc');

		$db->setQuery($query);
		$records = $db->loadObjectList();

		$positionData = array();
		foreach($records as $record){
			if(!isset($positionData[$record->position])){
				$positionData[$record->position] = [];
			}

			$positionData[$record->position][] = $record->field_id;
		}

		return $positionData;
	}

	public function deleteFieldValues($categoryId, $fields) {
		$db = $this->_db;

		$subQuery = 'SELECT `product_id` FROM `#__joomdownloads_product` '
					.'WHERE category_id = '.$db->quote($categoryId);

		
		$query = $db->getQuery(true);
		$query->delete()
				->from('`#__joomdownloads_fieldvalue`')
				->where('`field_id` IN ('.implode(',', $fields).')')
				->where('`product_id` IN ('.$subQuery.')');

		$db->setQuery($query);
		return $db->query();
	}
}

class JOOMDownloadsModelformCategory extends JOOMDownloadsModelform { }