<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Release Model
 * @author Gaurav Jain
 */
class JOOMDownloadsModelRelease extends JOOMDownloadsModel
{
	public $filterMatchOpeartor = array(
		'product_id' => array('='),
		'published' => array('='));

    public function getAccessRecords($releaseId)
    {
        $db = $this->_db;
        $query = $db->getQuery(true);
        $query->select('*')
            ->from('`#__joomdownloads_access`')
            ->where('`release_id` = '.$db->quote($releaseId));

        $db->setQuery($query);
        $records = $db->loadObjectList();

        $accessData = array();
        foreach($records as $record){
            if(!isset($accessData[$record->resource_type])){
                $accessData[$record->resource_type]['resource_id'] = $record->resource_id;
                continue;
            }

            if(!is_array($accessData[$record->resource_type]['resource_id'])){
                $accessData[$record->resource_type]['resource_id'] = array($accessData[$record->resource_type]['resource_id'], $record->resource_id);
                continue;
            }

            $accessData[$record->resource_type]['resource_id'][] = $record->resource_id;
        }

        return $accessData;
    }

    public function deleteAccessRecords($release_id)
    {
        $db = $this->_db;
        $query = $db->getQuery(true);
        $query->delete()
            ->from('`#__joomdownloads_access`')
            ->where('`release_id` = '.$db->quote($release_id));

        $db->setQuery($query);
        return $db->query();
    }

    public function insertAccessRecords($release_id, $accessData)
    {
        $db = $this->_db;
        $insert = array();
        foreach($accessData as $accessType => $data){
            if(empty($data['resource_id'])){
                continue;
            }

            if(!is_array($data['resource_id'])){
                $insert[] = '('.$db->quote($release_id).', '.$db->quote($accessType).', '.$db->quote($data['resource_id']).')';
                continue;
            }
            foreach($data['resource_id'] as $resource_id){
                $insert[] = '('.$db->quote($release_id).', '.$db->quote($accessType).', '.$db->quote($resource_id).')';
            }
        }

        if(empty($insert)){
            return true;
        }

        $db = $this->_db;
        $query = 'INSERT INTO `#__joomdownloads_access` (`release_id`, `resource_type`, `resource_id`) VALUES '.
            implode(',', $insert);

        $db->setQuery($query);
        return $db->query();
    }
}

class JOOMDownloadsModelformRelease extends JOOMDownloadsModelform { }