<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Category Table
 * @author Gaurav Jain
 */
class JOOMDownloadsTableCategory extends JOOMDownloadsTable
{
	/**
	 * 
	 * Method call to Get unique alias string
	 * 
	 * @param string $alias alias 	which ned to be properly generated 
	 * @param int	 $id			optional : id of category
	 * @param string $style
	 * 
	 * @return string The unique alias string.
	 */
	public static function getNewAlias($alias, $id = 0, $style = 'dash')
	{		
		$alias  = JApplicationHelper::stringURLSafe($alias);//Sluggify the input string
		if (trim(str_replace('-', '', $alias)) == '')
		{
			$alias = JFactory::getDate()->format('Y-m-d-H-i-s');
		}
		
		//@PCTODO:: move to helper
		// if Value already have '-'(dash) with numeric-data then remove numeric-data 
		$string = $alias;
		if (preg_match('#-(\d+)$#', $string, $matches)) {
			$string = preg_replace('#-(\d+)$#', sprintf('-', ''), $string);
		}
		
		$result = self::getRecordsOfAlias($alias, $id);		
		// build new column value
		while (in_array($alias, $result)) {
			$alias = JString::increment($alias, $style);
		}
		
		return $alias;		
	}
	
	public static function getRecordsOfAlias($alias, $id = 0)
	{
		$query 	= new JDQuery();
		$query->select('`alias`')
			  ->where("`alias` LIKE '".$alias."%'");
					  
		if(!empty($id)){
			$query->where("`category_id` <> ".intval($id));
		}
					  
		return $query->from('`#__joomdownloads_category`')
					 ->dbLoadQuery()->loadcolumn();
	}
	
	public function check()
	{
		$this->alias = trim($this->alias);
		if (empty($this->alias)){
			$this->alias = self::getNewAlias($this->title, $this->category_id);
		}
		
		return true;
	}
}
