<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Front-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;
JDHelperTemplate::loadMedia(array('angular'));
?>

<script>
var items = <?php echo json_encode($items);?>;

angular.module('applist', ['ngSanitize'])
  .controller('AppListController', function() {
    var applist = this;
  	applist.items = items;
  	applist.root = '<?php echo JURI::root();?>';
  	applist.loggedin = <?php echo $loggedin;?>;
  	applist.login_url = '<?php echo $login_url;?>';
  });
</script>
<div class="row-fluid">
	<div class="span12">
		<h1 class="jd-cat-title"><?php echo $category['title']; ?></h1>
	</div>
</div>
<div class="row-fluid">
	<?php if(!empty($category['image'])) : ?>
		<div class="span3">
			<div class="thumbnail">
				<img class="img-responsive" src="<?php echo $category['image'];?>">
			</div>
		</div>
		<div class="span9">
			<div class="jd-cat-description"><?php echo $category['description'];?></div>
		</div>
	<?php else : ?>
		<div class="span12">
			<div class="jd-cat-description"><?php echo $category['description'];?></div>
		</div>
	<?php endif;?>
</div>
<hr />
<div data-ng-app="applist" data-ng-controller="AppListController as applist">
	<div data-ng-repeat="item in applist.items" ng-if="$index % 3 == 0" class="row-fluid app-list">
		<div data-ng-repeat="index in [$index, $index+1, $index+2]" class="app span4">
			<div data-ng-show="applist.items[index]">
				<div class="thumbnail">
					<a data-ng-href="{{ applist.items[index].link }}">
						<img class="img-responsive jd-cat-item-image" ng-src="{{ applist.items[index].image }}">
					</a>
				</div>
				<div class="row-fluid">
					<h4 class="span12 text-center">
						<a class="jd-item-heading" data-ng-href="{{ applist.items[index].link }}">{{ applist.items[index].title }}</a></h4>
					<!-- <h4 class="span6">						
						<a data-ng-if="applist.loggedin == false" data-ng-href="{{ applist.login_url }}" class="btn btn-info pull-right"><i class="fa fa-lock"> </i> <?php echo JText::_('JLOGIN');?></a>

						<div data-ng-if="applist.loggedin" class="btn-group pull-right" role="group">
							<button type="button" class="btn btn-success dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
      							<i class="fa fa-download"> </i> <?php echo JText::_('COM_JOOMDOWNLOADS_DOWNLOAD');?>
      						<span class="caret"></span>
    						</button>
						    <ul class="dropdown-menu">
						    	<li data-ng-repeat="release in applist.items[index].release">
						      		<a data-ng-href="{{ release.link }}">{{ release.version }}</a>
						      	</li>						      	
						    </ul>
						</div>
					</h4>  -->
				</div>
				<small class="muted">
				<div class="row-fluid">
					<div class="span12">
						<div class="app-specs">
							<div class="row-fluid">
								<div data-ng-if="applist.items[index].last_updated_on">
									<div class="span6" title="<?php echo JText::_('COM_JOOMDOWNLOADS_LAST_UPDATED_ON');?>">
										<i class="fa fa-calendar"> </i> {{ applist.items[index].last_updated_on | date : 'short'}}
									</div>
									<div class="span6" title="<?php echo JText::_('COM_JOOMDOWNLOADS_DOWNLOADS');?>">
										<span class="pull-right">
											<i class="fa fa-download"> </i> {{ applist.items[index].downloads_count }} <?php echo JText::_('COM_JOOMDOWNLOADS_DOWNLOADS');?>
										</span>
									</div>
								</div>
								<div data-ng-hide="applist.items[index].last_updated_on">
									<div class="span6" title="<?php echo JText::_('COM_JOOMDOWNLOADS_DOWNLOADS');?>">
										<span>
											<i class="fa fa-download"> </i> {{ applist.items[index].downloads_count }} <?php echo JText::_('COM_JOOMDOWNLOADS_DOWNLOADS');?>
										</span>
									</div>
									<div class="span6">
										<span class="pull-right">
											<a data-ng-href="{{ applist.items[index].link }}"><?php echo JText::_('COM_JOOMDOWNLOADS_READ_MORE');?></a>
										</span>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="row-fluid">
					<div class="span12">
						<div class="app-specs">
							<div class="row-fluid">
								<div data-ng-if="applist.items[index].last_updated_on">
									<div class="span6" title="<?php echo JText::_('COM_JOOMDOWNLOADS_VERSION');?>">
										<span class="text-"><i class="fa fa-tag"> </i> {{ applist.items[index].latest_version }}</span>
									</div>
									<div class="span6">
										<span class="pull-right">
											<a data-ng-href="{{ applist.items[index].link }}"><?php echo JText::_('COM_JOOMDOWNLOADS_READ_MORE');?></a>
										</span>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				</small>
			</div>
		</div>
	</div>
</div>