<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Category Html View
* @author Gaurav Jain
 */
require_once dirname(__FILE__).'/view.php';
class JOOMDownloadsSiteViewCategory extends JOOMDownloadsSiteBaseViewCategory
{	
	public function display($tpl = null)
	{		
		$category = $this->input->get('id', '');

		$products = JOOMDownloadsFactory::getInstance('product', 'model')
						->loadRecords(array('published' => 1, 'category_id' => $category));

		$releases = JOOMDownloadsFactory::getInstance('release', 'model')
						->loadRecords(array('published' => 1));

		$sql = 'SELECT COUNT(download_id) as downloadCount, product_id FROM #__joomdownloads_download GROUP BY `product_id`';
		$db  = JFactory::getDBO();
		$db->setQuery($sql);
		$downloadCounts = $db->loadObjectList('product_id');

		$downloads 		= array();
		$lastUpdatedOn 	= array();
		$latestVersion  = array();
		foreach($releases as $release){
			if(!isset($downloads[$release->product_id])){
				$downloads[$release->product_id] = array();
			}

			if(!isset($lastUpdatedOn[$release->product_id])){
				$lastUpdatedOn[$release->product_id] = new JDDate($release->modified_date);
				$lastUpdatedOn[$release->product_id] = $lastUpdatedOn[$release->product_id]->toFormat('j M, Y');
			}
			else{
				$date1 = new JDdate($lastUpdatedOn[$release->product_id]);
				$date2 = new JDdate($release->modified_date);
				$lastUpdatedOn[$release->product_id] = $date1->toUnix() > $date2->toUnix() ? $date1->toFormat('j M, Y') :  $date2->toFormat('j M, Y');
			}

			if(!isset($latestVersion[$release->product_id])){
				$latestVersion[$release->product_id] = $release->version;
			}
			else{				
				$latestVersion[$release->product_id] = version_compare($latestVersion[$release->product_id], $release->version) == -1 ? $release->version :  $latestVersion[$release->product_id];
			}
			
			// $downloads[$release->product_id][] = array('version' => $release->version, 'link' => JRoute::_('index.php?option=com_joomdownloads&view=download&task=download&product_id='.$release->product_id.'&release_id='.$release->release_id, false)); 
		}

		$items = array();
		foreach ($products as $product) {
			$object                  = new stdClass();
			$object->product_id		 = $product->product_id;
			$object->alias           = $product->alias;
			$object->title           = $product->title;
			$object->downloads_count = isset($downloadCounts[$product->product_id]) ? $downloadCounts[$product->product_id]->downloadCount : 0;
			$object->last_updated_on = isset($lastUpdatedOn[$product->product_id]) ? $lastUpdatedOn[$product->product_id] : '';
			$object->latest_version = isset($latestVersion[$product->product_id]) ? $latestVersion[$product->product_id] : '0.0.0';
			
			if(!empty($product->image)){
				$object->image 	= JURI::root().$product->image;
			}
			else{
				$object->image 	= JURI::root().'media/com_joomdownloads/images/product.png';
			}
			
			$object->link            = JRoute::_(JOOMDownloadsHelperRoute::getProductRoute($product->product_id, $product->category_id ), false);
			$object->release         = array();

			// if(isset($downloads[$product->product_id])){				
			// 	$object->release = $downloads[$product->product_id];				
			// }
			
			$items[] = $object;
		}

		$user = JFactory::getUser();
		$loggedin = 0;
		if($user->id){
			$loggedin = 1;
		}

		$loginUrl = 'index.php?option=com_users&view=login&return='.JOOMDownloadsFactory::getHelper('utils')->getReturnUrl();
		$this->assign('login_url', JRoute::_($loginUrl));
		$this->assign('loggedin', $loggedin);
		$category = JOOMDownloadsCategory::getInstance($category)->toArray();
		if(!empty($category['image'])){
			$category['image'] 	= JURI::root().$category['image'];
		}
		$this->assign('category', $category);
		$this->assign('items', $items);
		return true;
	}

	protected function generateMetadata()
	{	       		
       	$category = $this->get('category', false);
       	if($category){
	       	if(isset($category['params']) && isset($category['params']['metadata'])){
				$title 		= @$category['params']['metadata']['title'];
				$keywords 	= @$category['params']['metadata']['keywords'];
				$description= @$category['params']['metadata']['description'];
				JDHelperJoomla::addDocumentMetadata($title, $keywords, $description, '', $category['image']);
				return;
	       	}
	    }

       	parent::generateMetadata();		
	}

	public function _basicFormSetup($task)
	{
		return true;
	}
}
