<?php

/**
* @copyright	Copyright (C) 2015 Codextrous . All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package 		JOOMDOWNLOADS
* @subpackage	Back-end
* @contact		contact@codextrous.com
*/

// no direct access
defined('_JEXEC') or die;

/** 
 * Product Html View
* @author Gaurav Jain
 */
require_once dirname(__FILE__).'/view.php';
class JOOMDownloadsSiteViewProduct extends JOOMDownloadsSiteBaseViewProduct
{	
	public function display($tpl = null)
	{	
		$product_id = $this->get('product_id');
		$product 	= JOOMDownloadsProduct::getInstance($product_id);

		$product 	= $product->toArray();

		if(!empty($product['image'])){
			$product['image'] 	= JURI::root().$product['image'];
		}
		else{
			$product['image'] 	= JURI::root().'media/com_joomdownloads/images/product.png';
		}

		$releases = JOOMDownloadsFactory::getInstance('release', 'model')
						->loadRecords(array('published' => 1, 'product_id' => $product_id));

		$downloads = array();
		foreach($releases as $release){
			$downloads[] = array(
							'version' => $release->version, 
							'link' => JRoute::_(JOOMDownloadsHelperRoute::getProductDownloadRoute($release->product_id, $product['category_id'], $release->release_id), false)); 
		}

		$user = JFactory::getUser();
		$loggedin = 0;
		if($user->id){
			$loggedin = 1;
		}

		$this->assign('loggedin', $loggedin);
		
		// be default it is allowed
		$product['allowed'] = true;
		$this->assign('releases_link', JRoute::_(JOOMDownloadsHelperRoute::getProductReleasesRoute($product_id, $product['category_id']), false));
		$this->assign('product', $product);
		$this->assign('downloads', $downloads);
//		$this->assign('accessData', JOOMDownloadsFactory::getInstance('product', 'model')->getAccessRecords($product_id));


		$enableFields = JDHelperJoomla::getPluginStatus('fields', 'joomdownloads');
		$fieldValues  = array();
		$positionData = array();
		if($enableFields) {
			$fieldValues  = $this->getModel()->getFieldValues($product_id);			
			$positionData = JOOMDownloadsFactory::getInstance('category', 'model')
							->getFieldPositionRecords($product['category_id']);
		}

		$this->assign('enableFields', $enableFields);
		$this->assign('fieldValues',  $fieldValues);
		$this->assign('positionData', $positionData);

		JDHelperJoomla::loadPlugins('joomdownloads');
		
		return true;
	}


	protected function generateMetadata()
	{	       		
       	$product = $this->get('product', array());
       	if(isset($product['params']) && isset($product['params']['metadata'])){
			$title 		= @$product['params']['metadata']['title'];
			if(empty($title)){
				$title = $product['title'];
			}
			$keywords 	= @$product['params']['metadata']['keywords'];
			$description= @$product['params']['metadata']['description'];
			JDHelperJoomla::addDocumentMetadata($title, $keywords, $description, '', $product['image']);
       	}
       	else{
       		parent::generateMetadata();
       	}		
	}

	public function _basicFormSetup($task)
	{
		return true;
	}
	
	public function releases()
	{
		$product_id = $this->get('product_id');
		$product 	= JOOMDownloadsProduct::getInstance($product_id);

		$product 	= $product->toArray();

		$releases = JOOMDownloadsFactory::getInstance('release', 'model')
						->loadRecords(array('published' => 1, 'product_id' => $product_id));

		
		
		$downloads = array();
		foreach($releases as $index => $release){
			$accessData   = JOOMDownloadsFactory::getInstance('release', 'model')
									->getAccessRecords($release->release_id);
			
			$releases[$index]->access_data = $accessData;
			$releases[$index]->button = "<a href=".JRoute::_(JOOMDownloadsHelperRoute::getProductDownloadRoute($release->product_id, $product['category_id'], $release->release_id), false)." class='btn btn-success'>
					  			<i class='fa fa-download'> </i> Download </a>";
			
	//		$downloads[] = array(
	//						'version' => $release->version, 
	//						//'link' => JRoute::_(JOOMDownloadsHelperRoute::getProductDownloadRoute($release->product_id, $product['category_id'], $release->release_id), false),
	//						'modified_date'=>$release->modified_date,
	//						'button'=>"<a href=".JRoute::_(JOOMDownloadsHelperRoute::getProductDownloadRoute($release->product_id, $product['category_id'], $release->release_id), false)." class='btn btn-success'>
	//				  			<i class='fa fa-download'> </i> </a>");

		}

		$args   = array($product, &$releases);
		JDHelperJoomla::loadPlugins('joomdownloads');
		$pluginResult = JDHelperJoomla::triggerPlugin('onJoomdownloadsReleasesRender',$args, '', $this);
		
		$this->assign('product', $product);
		$this->assign('releases', $releases);
	//	$this->assign('downloads', $downloads);
		
		$this->setTpl('release');
		return true;
	}
}
